import * as i0 from '@angular/core';
import { Component, Input, ViewChild, Directive, HostListener, NgModule } from '@angular/core';
import { UploadWidget } from '@bytescale/upload-widget';

class UploadDropzoneComponent {
    options;
    onComplete;
    onUpdate;
    width = "600px";
    height = "375px";
    container;
    ngAfterViewInit() {
        const onUpdateParams = this.onUpdate === undefined ? {} : { onUpdate: this.onUpdate };
        UploadWidget.open({
            ...this.getOptions(),
            ...onUpdateParams,
            container: this.container.nativeElement,
            layout: "inline"
        }).then(files => {
            if (this.onComplete !== undefined) {
                this.onComplete(files);
            }
        }, error => console.error("Uploader error.", error));
    }
    getOptions() {
        if (this.options === undefined) {
            throw new Error("[bytescale-upload-widget] You must provide the 'options' attribute to the 'UploadDropzone' component.");
        }
        return this.options;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.4", ngImport: i0, type: UploadDropzoneComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.4", type: UploadDropzoneComponent, selector: "upload-dropzone", inputs: { options: "options", onComplete: "onComplete", onUpdate: "onUpdate", width: "width", height: "height" }, viewQueries: [{ propertyName: "container", first: true, predicate: ["container"], descendants: true }], ngImport: i0, template: `
    <div
      #container
      style="position: relative; width: 100%; min-width: 280px; maxWidth: {{ width }}; height: {{ height }}"
    ></div>
  `, isInline: true });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.4", ngImport: i0, type: UploadDropzoneComponent, decorators: [{
            type: Component,
            args: [{ selector: "upload-dropzone", template: `
    <div
      #container
      style="position: relative; width: 100%; min-width: 280px; maxWidth: {{ width }}; height: {{ height }}"
    ></div>
  ` }]
        }], propDecorators: { options: [{
                type: Input,
                args: ["options"]
            }], onComplete: [{
                type: Input,
                args: ["onComplete"]
            }], onUpdate: [{
                type: Input,
                args: ["onUpdate"]
            }], width: [{
                type: Input,
                args: ["width"]
            }], height: [{
                type: Input,
                args: ["height"]
            }], container: [{
                type: ViewChild,
                args: ["container"]
            }] } });

class UploadButtonDirective {
    options;
    onComplete;
    onClick(event) {
        event.preventDefault();
        UploadWidget.open(this.getOptions()).then(files => {
            if (this.onComplete !== undefined) {
                this.onComplete(files);
            }
        }, error => console.error("Uploader error.", error));
    }
    ngOnInit() {
        try {
            this.getOptions();
        }
        catch (e) {
            console.error(e);
        }
    }
    getOptions() {
        if (this.options === undefined) {
            throw new Error("[bytescale-upload-widget] You must provide the 'uploadOptions' attribute to elements marked with the 'uploadButton' directive.");
        }
        return this.options;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.4", ngImport: i0, type: UploadButtonDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
    static ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "17.3.4", type: UploadButtonDirective, selector: "[uploadButton]", inputs: { options: ["uploadOptions", "options"], onComplete: ["uploadComplete", "onComplete"] }, host: { listeners: { "click": "onClick($event)" } }, ngImport: i0 });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.4", ngImport: i0, type: UploadButtonDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: "[uploadButton]"
                }]
        }], propDecorators: { options: [{
                type: Input,
                args: ["uploadOptions"]
            }], onComplete: [{
                type: Input,
                args: ["uploadComplete"]
            }], onClick: [{
                type: HostListener,
                args: ["click", ["$event"]]
            }] } });

class UploadWidgetModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.4", ngImport: i0, type: UploadWidgetModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.4", ngImport: i0, type: UploadWidgetModule, declarations: [UploadDropzoneComponent, UploadButtonDirective], exports: [UploadDropzoneComponent, UploadButtonDirective] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.4", ngImport: i0, type: UploadWidgetModule });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.4", ngImport: i0, type: UploadWidgetModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UploadDropzoneComponent, UploadButtonDirective],
                    imports: [],
                    exports: [UploadDropzoneComponent, UploadButtonDirective]
                }]
        }] });

/*
 * Public API Surface of @bytescale/upload-widget-angular
 */

/**
 * Generated bundle index. Do not edit.
 */

export { UploadButtonDirective, UploadDropzoneComponent, UploadWidgetModule };
//# sourceMappingURL=bytescale-upload-widget-angular.mjs.map
